=== debian/changelog ===
openxray (1.6.02-15) UNRELEASED; urgency=medium

  * Move to use gcc-14

 -- Krzysztof Sobiecki <sobkas@sobkas.io>  Tue, 07 May 2024 01:12:42 +0200

openxray (1.6.02-14) experimental; urgency=medium

  * Update *.install files

 -- Krzysztof Sobiecki <sobkas@sobkas.io>  Sat, 04 May 2024 20:15:57 +0200

openxray (1.6.02-13) experimental; urgency=medium

  * Update debian build infrastructure
  * Switch to quilt
  * Update source format
  * Add symbol file
  * Make packages multi-arch compliant
  * Explicit install files

 -- Krzysztof Sobiecki <sobkas@sobkas.io>  Sat, 19 Aug 2023 01:54:15 +0200

openxray (1.6.02-12-ubuntu1) disco; urgency=medium

  * move shlib to /usr/lib
  * try auto dep

  * fix build

 -- Ilya Orlov <eagleivg@mail.ru>  Sun, 23 Jun 2019 14:46:00 +0300
