=== ArchLinux/PKGBUILD ===
# Contributor: chip_exe
# https://aur.archlinux.org/packages/openxray-git/
# <openxray@yahoo.com>
#This PKGBUILD compiles the package without downloading the source code. It is mainly intended for developers who use
#ArchLinux or Majaro.
#To build the package, open a terminal, go to the xray-16/ArchLinux directory and run the makepkg -fi command
#where the options are -f to overwrite the package if it was built before that -i install the package after the build.
pkgname=openxray-dev                                    
pkgver=1.6.02_
pkgrel=1          
pkgdesc="Unofficial X-Ray Engine Linux port by OpenXRay team (Originally developed by GSC Game World)"                                          
arch=('x86_64') 
url="https://github.com/OpenXRay/xray-16"
license=('custom:Custom 3-сlause BSD')
install="info.install"
makedepends=(gcc git cmake libglvnd libjpeg6-turbo ncurses pcre2 pcre)
depends=(glew sdl2 openal crypto++ freeimage libogg libtheora libvorbis lzo lzop libjpeg-turbo)
conflicts=(openxray openxray-git)

pkgver() {
  cd ../..
  printf 1.6.02_"$(git rev-parse --short HEAD)"
}

build() {
   cd ../..
#  rm -f -R bin
   mkdir -p bin
   cd bin
   cmake .. -DCMAKE_BUILD_TYPE=Release \
   -DCMAKE_INSTALL_PREFIX=/usr \
   -DCMAKE_INSTALL_LIBDIR=lib
   make
}

package() {
    cd ../../bin
    make DESTDIR="${pkgdir}/" install
    mkdir -p "${pkgdir}/usr/share/licenses/$pkgname/"
    cp ../License.txt "${pkgdir}/usr/share/licenses/$pkgname/"
}
